'' HC4LED_Demo
'' -- Jon Williams, Parallax
'' -- 16 MAY 2006


CON

  _CLKMODE      = XTAL1 + PLL8X
  _XINFREQ      = 10_000_000

  D_PIN         = 0
  C_PIN         = 1
  E_PIN         = 2

  DEG_SYM       = %00001111                             ' degrees symbol


VAR

  long  count, idx
  byte  buf[4]


OBJ

  leds  : "hc4led"

  
PUB main

  leds.startx(D_PIN, C_PIN, E_PIN)                      ' start with display enable pin
  leds.display(true)

  ' string method

  leds.str(string("HC4"))
  waitcnt(clkfreq + cnt)
  leds.str(string(" LEd"))
  waitcnt(clkfreq + cnt)

  ' animation demo
  
  repeat 5
    repeat idx from 0 to 11
      leds.writex(@Chaser + (idx * 4))
      waitcnt(clkfreq / 15 + cnt)

  ' mix characters and custom segments
  
  leds.write(leds.segdata("7"), leds.segdata("2"), DEG_SYM, leds.segdata("F"))
  waitcnt(clkfreq + cnt)

  ' flash display

  repeat 5
    leds.display(false)
    waitcnt(clkfreq / 5 + cnt)
    leds.display(true)
    waitcnt(clkfreq / 5 + cnt)  

  ' demo standard methods  

  blank
  repeat count from -99 to 99
    leds.dec(count)
    waitcnt(clkfreq / 10 + cnt)

  blank
  repeat count from 0 to $FF
    leds.hex(count, 2)
    waitcnt(clkfreq / 10 + cnt)

  blank
  repeat count from 0 to %1111
    leds.bin(count, 4)
    waitcnt(clkfreq / 5 + cnt)      

  ' more animation
  
  blank
  repeat  
    repeat idx from 0 to 5
      leds.writex(@Bugs + (idx * 4))
      waitcnt(clkfreq / 10 + cnt)


PRI blank

  leds.cls
  waitcnt(clkfreq / 2 + cnt)
  

DAT
                        ' Col 1      Col2       Col3       Col4
                        ' edcbafg    edcbafg    edcbafg    edcbafg
  Chaser      byte      %00000100, %00000000, %00000000, %00000000
              byte      %00000000, %00000100, %00000000, %00000000
              byte      %00000000, %00000000, %00000100, %00000000
              byte      %00000000, %00000000, %00000000, %00000100
              byte      %00000000, %00000000, %00000000, %00001000
              byte      %00000000, %00000000, %00000000, %00010000
              byte      %00000000, %00000000, %00000000, %00100000
              byte      %00000000, %00000000, %00100000, %00000000
              byte      %00000000, %00100000, %00000000, %00000000
              byte      %00100000, %00000000, %00000000, %00000000
              byte      %01000000, %00000000, %00000000, %00000000
              byte      %00000010, %00000000, %00000000, %00000000


  Bugs        byte      %00000100, %00000010, %01000000, %00100000
              byte      %00001000, %00000100, %00000010, %01000000
              byte      %00010000, %00001000, %00000100, %00000010
              byte      %00100000, %00010000, %00001000, %00000100
              byte      %01000000, %00100000, %00010000, %00001000
              byte      %00000010, %01000000, %00100000, %00010000                                                          
                                                         
                                                         